#pragma once

// Nbv{[hĎ
class ClipbordWatcher {
	HWND m_hWnd;
	HWND m_hWndNext;
public:
	ClipbordWatcher() {
		m_hWnd = NULL;
		m_hWndNext = NULL;
	}

	virtual ~ClipbordWatcher() {
		if (IsStarted())
			End();
	}

	BOOL IsStarted() {
		return m_hWnd != NULL;
	}

	BOOL Start(HWND hWnd) {
		if (IsStarted())
			return FALSE;

		m_hWnd = hWnd;
		m_hWndNext = SetClipboardViewer(m_hWnd);
		if (m_hWndNext == NULL && GetLastError() != 0) {
			m_hWnd = NULL;
			return FALSE;
		}
		return TRUE;
	}

	BOOL End() {
		if (!IsStarted())
			return FALSE;
		ChangeClipboardChain(m_hWnd, m_hWndNext);
		m_hWnd = NULL;
		m_hWndNext = NULL;
		return TRUE;
	}

	void ChangeCbChain(HWND hWndRemove, HWND hWndNext) {
		if (m_hWndNext == hWndRemove)
			m_hWndNext = hWndNext;
		if (m_hWndNext != NULL) 
			SendMessage(m_hWndNext, WM_CHANGECBCHAIN, (WPARAM)hWndRemove, (LPARAM)hWndNext);
	}

	void DrawClipboard() {
		if (m_hWndNext != NULL)
			SendMessage(m_hWndNext, WM_DRAWCLIPBOARD , 0, 0);
	}

	BOOL Read(std::string& buf)
	{
		HGLOBAL hGlobal;

		if(!IsClipboardFormatAvailable(CF_TEXT)) {
			return FALSE;
		}
		OpenClipboard(m_hWnd);
		hGlobal = (HGLOBAL)GetClipboardData(CF_TEXT);
		if (hGlobal == NULL) {
			CloseClipboard();
			return FALSE;
		}
		buf = (LPSTR)GlobalLock(hGlobal);

		GlobalUnlock(hGlobal);
		CloseClipboard();
		return TRUE;
	}

};
